using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Data.SqlClient;

public partial class CompanyDictionary_TableDesc : System.Web.UI.Page
{
    protected String sHTML = "";
    protected String sTableName = "";
    protected String sTableDesc = "";
    protected String sColumnListElements;
    protected String sCaveatListElements;
    public String sDBID = "";
    public String sTABLEID = "";
    protected void Page_Load(object sender, EventArgs e)
    {
        //Pull in the database ID from the HTTP GET.
        sDBID = Request.QueryString.Get("DBID");

        //Pull in the table ID from the HTTP GET.
        sTABLEID = Request.QueryString.Get("TABLEID");

        //Pull in the name of the table from the database based on the sDBID and sTABLEID.
        sTableName = GetTableName(sDBID, sTABLEID);

        //Pull in table description from the database based on the sDBID and sTABLEID.
        sTableDesc = GetTableDesc(sDBID, sTABLEID);

        //Pull in columns for the requested table creating unordered list elements for each.
        sColumnListElements = GetColumnListElements(sDBID, sTABLEID);

        //Pull in caveats for the requested table creating unordered list elements for each.
        sCaveatListElements = GetCaveatListElements(sDBID, sTABLEID);

        //Build the HTML string for use in displaying the webpage.
        WriteOutHTML();
    }

    //Pull the table name from the database.
    public String GetTableName(String psDBID,String psTABLEID)
    {

        String sTblNm="";

        //Connect to the database.
        const String sConn = @"Data Source=SCOTT-LAPTOP\SQLEXPRESS;Initial Catalog=TESTDB;Integrated Security=SSPI;";
        SqlConnection oConn = new SqlConnection(sConn);
        oConn.Open();

        //Create a SQL Command object to hold the appropriate SQL to pull the table name from the dictionary.
        SqlCommand oCmd = new SqlCommand("SELECT TABLE_NAME FROM DATADICT_TABLE_NAME WHERE DB_ID=" + psDBID + " AND TABLE_ID=" + psTABLEID, oConn);
        SqlDataReader oRdr = oCmd.ExecuteReader();
        oRdr.Read();
        sTblNm = (String)oRdr["TABLE_NAME"];

        //Close the reader object.
        oRdr.Close();

        return (sTblNm);
    }

    //Generate the columns for the requested table as HTML table rows
    public void WriteOutHTML()
    {
        //Create a format string used to create the table rows and their associated table data.
        String sFormat = "<tr><td class=\"tdsty\">{0}</td><td class=\"tdsty\">{1}</td><td class=\"tdsty\">{2}</td></tr>";

        //Connect to the database.
        const String sConn = @"Data Source=SCOTT-LAPTOP\SQLEXPRESS;Initial Catalog=TESTDB;Integrated Security=SSPI;";
        SqlConnection oConn = new SqlConnection(sConn);
        oConn.Open();

        //Create a SQL Command object to hold the appropriate SQL to pull the list of columns for the requested table from the dictionary.
        SqlCommand oCmd = new SqlCommand("SELECT DB_ID,TABLE_ID,COLUMN_ID,COLUMN_NAME,DATA_TYPE,NULLABILITY FROM DATADICT_COLUMN_DEFN WHERE DB_ID=" + sDBID + " AND TABLE_ID=" + sTABLEID + " ORDER BY 3", oConn);
        SqlDataReader oRdr = oCmd.ExecuteReader();

        //Build the string sHTML to hold the list of columns for the requested tables.
        while (oRdr.Read())
        {
            sHTML += String.Format(sFormat, new object[] { (String)oRdr["COLUMN_NAME"], (String)oRdr["DATA_TYPE"], (String)oRdr["NULLABILITY"] });
        }

        //Close the reader object.
        oRdr.Close();
    }

    //Pull the table description from the dictionary.
    public String GetTableDesc(String psDBID, String psTABLEID)
    {

        String sTblDsc = "";

        //Connect to the database.
        const String sConn = @"Data Source=SCOTT-LAPTOP\SQLEXPRESS;Initial Catalog=TESTDB;Integrated Security=SSPI;";
        SqlConnection oConn = new SqlConnection(sConn);
        oConn.Open();

        //Create a SQL Command object to hold the appropriate SQL to pull the table description from the dictionary.
        SqlCommand oCmd = new SqlCommand("SELECT TABLE_DESC FROM DATADICT_TABLE_DESC WHERE DB_ID=" + psDBID + " AND TABLE_ID=" + psTABLEID, oConn);
        SqlDataReader oRdr = oCmd.ExecuteReader();
        oRdr.Read();
        sTblDsc = (String)oRdr["TABLE_DESC"];

        //Close the reader object.
        oRdr.Close();

        return (sTblDsc);
    }

    //Generate the columns as list elements.
    public String GetColumnListElements(String psDBID, String psTABLEID)
    {

        String sListElts = "";

        //Create a format string used to create the list elements.
        String sFormat = "<li class=\"listy\">{0}: {1}</li>";

        //Connect to the database.
        const String sConn = @"Data Source=SCOTT-LAPTOP\SQLEXPRESS;Initial Catalog=TESTDB;Integrated Security=SSPI;";
        SqlConnection oConn = new SqlConnection(sConn);
        oConn.Open();

        //Create a SQL Command object to hold the appropriate SQL to pull the columns from the dictionary.
        SqlCommand oCmd = new SqlCommand("SELECT COLUMN_NAME,COLUMN_DESC FROM DATADICT_COLUMN_DESC WHERE DB_ID=" + sDBID + " AND TABLE_ID=" + sTABLEID + " ORDER BY COLUMN_ID", oConn);
        SqlDataReader oRdr = oCmd.ExecuteReader();

        //Build the string sHTML to hold the columns from the requested table.
        while (oRdr.Read())
        {
            sListElts += String.Format(sFormat, new object[] { (String)oRdr["COLUMN_NAME"], (String)oRdr["COLUMN_DESC"]});
        }

        //Close the reader object.
        oRdr.Close();

        return (sListElts);
    }

    //Generate the caveats as list elements.
    public String GetCaveatListElements(String psDBID, String psTABLEID)
    {

        String sCaveatElts = "";

        //Create a format string used to create the list elements.
        String sFormat = "<li class=\"listy\">{0}</li>";

        //Connect to the database.
        const String sConn = @"Data Source=SCOTT-LAPTOP\SQLEXPRESS;Initial Catalog=TESTDB;Integrated Security=SSPI;";
        SqlConnection oConn = new SqlConnection(sConn);
        oConn.Open();

        //Create a SQL Command object to hold the appropriate SQL to pull the caveats for the requested table from the dictionary.
        SqlCommand oCmd = new SqlCommand("SELECT CAVEAT_ID,CAVEAT_DESC FROM DATADICT_CAVEAT_DESC WHERE DB_ID=" + sDBID + " AND TABLE_ID=" + sTABLEID + " ORDER BY CAVEAT_ID", oConn);
        SqlDataReader oRdr = oCmd.ExecuteReader();

        //Build the string sHTML to hold the caveats.
        while (oRdr.Read())
        {
            sCaveatElts += String.Format(sFormat, new object[] {(String)oRdr["CAVEAT_DESC"]});
        }

        //Close the reader object.
        oRdr.Close();

        return (sCaveatElts);
    }

}