using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Data.SqlClient;

public partial class CompanyDictionary_FuncProcDesc : System.Web.UI.Page
{
    protected String sHTML = "";
    protected String sFuncProcName = "";
    protected String sFuncProcDesc = "";
    protected String sArgumentListElements;
    protected String sCaveatListElements;
    public String sDBID = "";
    public String sFUNCPROCID = "";
    protected void Page_Load(object sender, EventArgs e)
    {
        //Pull in the database ID from the HTTP GET.
        sDBID = Request.QueryString.Get("DBID");

        //Pull in the function/procedure ID from the HTTP GET.
        sFUNCPROCID = Request.QueryString.Get("FUNCPROCID");

        //Pull in the name of the function/procedure from the database based on the sDBID and sFUNCPROCID.
        sFuncProcName = GetFuncProcName(sDBID, sFUNCPROCID);

        //Pull in function description from the database based on the sDBID and sFUNCPROCID.
        sFuncProcDesc = GetFuncProcDesc(sDBID, sFUNCPROCID);

        //Pull in argument for the requested function/procedure creating unordered list elements for each.
        sArgumentListElements = GetArgumentListElements(sDBID, sFUNCPROCID);

        //Pull in caveats for the requested table creating unordered list elements for each.
        sCaveatListElements = GetCaveatListElements(sDBID, sFUNCPROCID);

        //Build the HTML string for use in the display of the webpage.
        WriteOutHTML();
    }

    //Pull the function/procedure name from the database.
    public String GetFuncProcName(String psDBID,String psFUNCPROCID)
    {

        String sFuncProcNm="";

        //Connect to the database.
        const String sConn = @"Data Source=SCOTT-LAPTOP\SQLEXPRESS;Initial Catalog=TESTDB;Integrated Security=SSPI;";
        SqlConnection oConn = new SqlConnection(sConn);
        oConn.Open();

        //Create a SQL Command object to hold the appropriate SQL to pull the name of the function/procedure from the dictionary.
        SqlCommand oCmd = new SqlCommand("SELECT FUNCPROC_NAME FROM DATADICT_FUNCPROC_NAME WHERE DB_ID=" + psDBID + " AND FUNCPROC_ID=" + psFUNCPROCID, oConn);
        SqlDataReader oRdr = oCmd.ExecuteReader();
        oRdr.Read();
        sFuncProcNm = (String)oRdr["FUNCPROC_NAME"];

        //Close the reader object.
        oRdr.Close();

        return (sFuncProcNm);
    }

    //Generate the HTML table rows containing the list of function/procedure arguments, direction and data type.
    public void WriteOutHTML()
    {
        //Create a format string used to create the table rows and their associated table data.
        String sFormat = "<tr><td class=\"tdsty\">{0}</td><td class=\"tdsty\">{1}</td><td class=\"tdsty\">{2}</td></tr>";

        //Connect to the database.
        const String sConn = @"Data Source=SCOTT-LAPTOP\SQLEXPRESS;Initial Catalog=TESTDB;Integrated Security=SSPI;";
        SqlConnection oConn = new SqlConnection(sConn);
        oConn.Open();

        //Create a SQL Command object to hold the appropriate SQL to display pull the function/procedure arguments from the dictionary.
        SqlCommand oCmd = new SqlCommand("SELECT DB_ID,FUNCPROC_ID,ARGUMENT_ID,ARGUMENT_NAME,DIRECTION,DATATYPE FROM DATADICT_ARGUMENT_DEFN WHERE DB_ID=" + sDBID + " AND FUNCPROC_ID=" + sFUNCPROCID + " ORDER BY 3", oConn);
        SqlDataReader oRdr = oCmd.ExecuteReader();

        //Build the string sHTML to hold the function/procedure arguments.
        while (oRdr.Read())
        {
            sHTML += String.Format(sFormat, new object[] { (String)oRdr["ARGUMENT_NAME"], (String)oRdr["DIRECTION"], (String)oRdr["DATATYPE"] });
        }

        //Close the reader object.
        oRdr.Close();
    }

    //Pull the function/procedure description from the dictionary.
    public String GetFuncProcDesc(String psDBID, String psFUNCPROCID)
    {

        String sFuncProcDsc = "";

        //Connect to the database.
        const String sConn = @"Data Source=SCOTT-LAPTOP\SQLEXPRESS;Initial Catalog=TESTDB;Integrated Security=SSPI;";
        SqlConnection oConn = new SqlConnection(sConn);
        oConn.Open();

        //Create a SQL Command object to hold the appropriate SQL to pull the function/procedure name from the dictionary.
        SqlCommand oCmd = new SqlCommand("SELECT FUNCPROC_DESC FROM DATADICT_FUNCPROC_DESC WHERE DB_ID=" + psDBID + " AND FUNCPROC_ID=" + psFUNCPROCID, oConn);
        SqlDataReader oRdr = oCmd.ExecuteReader();
        oRdr.Read();
        sFuncProcDsc = (String)oRdr["FUNCPROC_DESC"];

        //Close the reader object.
        oRdr.Close();

        return (sFuncProcDsc);
    }

    //Generate the HTML list elements containing the function/procedure arguments.
    public String GetArgumentListElements(String psDBID, String psFUNCPROCID)
    {

        String sListElts = "";

        //Create a format string used to create the table rows and their associated table data.
        String sFormat = "<li class=\"listy\">{0}: {1}</li>";

        //Connect to the database.
        const String sConn = @"Data Source=SCOTT-LAPTOP\SQLEXPRESS;Initial Catalog=TESTDB;Integrated Security=SSPI;";
        SqlConnection oConn = new SqlConnection(sConn);
        oConn.Open();

        //Create a SQL Command object to hold the appropriate SQL to pull the function/procedure arguments from the dictionary.
        SqlCommand oCmd = new SqlCommand("SELECT ARGUMENT_NAME,ARGUMENT_DESC FROM DATADICT_ARGUMENT_DESC WHERE DB_ID=" + sDBID + " AND FUNCPROC_ID=" + sFUNCPROCID + " ORDER BY ARGUMENT_ID", oConn);
        SqlDataReader oRdr = oCmd.ExecuteReader();

        //Build the string sHTML to hold the function/procedure arguments.
        while (oRdr.Read())
        {
            sListElts += String.Format(sFormat, new object[] { (String)oRdr["ARGUMENT_NAME"], (String)oRdr["ARGUMENT_DESC"]});
        }

        //Close the reader object.
        oRdr.Close();

        return (sListElts);
    }

    //Generate the list elements for the caveats for the requested function/procedure.
    public String GetCaveatListElements(String psDBID, String psFUNCPROCID)
    {

        String sCaveatElts = "";

        //Create a format string used to create the table rows and their associated table data.
        String sFormat = "<li class=\"listy\">{0}</li>";

        //Connect to the database.
        const String sConn = @"Data Source=SCOTT-LAPTOP\SQLEXPRESS;Initial Catalog=TESTDB;Integrated Security=SSPI;";
        SqlConnection oConn = new SqlConnection(sConn);
        oConn.Open();

        //Create a SQL Command object to hold the appropriate SQL to pull the caveats for the requested function/procedure from the dictionary.
        SqlCommand oCmd = new SqlCommand("SELECT CAVEAT_ID,CAVEAT_DESC FROM DATADICT_FUNCPROCCAVEAT_DESC WHERE DB_ID=" + sDBID + " AND FUNCPROC_ID=" + sFUNCPROCID + " ORDER BY CAVEAT_ID", oConn);
        SqlDataReader oRdr = oCmd.ExecuteReader();

        //Build the string sHTML to hold the caveats.
        while (oRdr.Read())
        {
            sCaveatElts += String.Format(sFormat, new object[] {(String)oRdr["CAVEAT_DESC"]});
        }

        //Close the reader object.
        oRdr.Close();

        return (sCaveatElts);
    }

}