<?php

 #*------------------------------------------------------------*
 #* Pull in the DBID GET Variable from the link.               *
 #*------------------------------------------------------------*
 $DBID = $_GET["DBID"];

 #*------------------------------------------------------------*
 #* Pull in the TABLEID GET Variable from the link.            *
 #*------------------------------------------------------------*
 $TABLEID = $_GET["TABLEID"];

 #*------------------------------------------------------------*
 #* Connect to the TESTDB MySQL database on the localhost.     *
 #* You will have to change localhost to the location of your  *
 #* database.  Contact your web administrator for more info.   *
 #*------------------------------------------------------------*
 $oConn = new mysqli("localhost","scott","tiger","TESTDB");

 #*------------------------------------------------------------*
 #* Ensure that the connection was successful.                 *
 #*------------------------------------------------------------*
 if ($oConn->connect_errno) {
  printf("Connection failed: %s\n", $oConn->connect_error);
  exit();
 }

 #*------------------------------------------------------------*
 #* Pull the name of the table based on the TABLEID.           *
 #*------------------------------------------------------------*
 $sQueryTABLENAME = "SELECT TABLE_NAME FROM DATADICT_TABLE_NAME WHERE DB_ID=" . $DBID . " AND TABLE_ID=" . $TABLEID;

 #*------------------------------------------------------------*
 #* Query the dictionary to get the table name.                *
 #*------------------------------------------------------------*
 $oResult = $oConn->query($sQueryTABLENAME);
 $oRow = $oResult->fetch_assoc();
 $sTableName = $oRow['TABLE_NAME'];

?>

<html>
 <head>
  <title>Company Dictionary - Table Description</title>
    <style type="text/css">
        table.tblsty {
            font-family: Verdana,sans-serif;
            font-size: 9pt;
            border: 1px solid black;
            border-collapse: collapse;
            border-spacing: 20px;
        }

        th.thsty1 {
            text-align: left;
            font-weight: bold;
            border: 1px solid black;
            background: #808080;
        }

        th.thsty2 {
            text-align: center;
            font-weight: bold;
            border: 1px solid black;
            background: #c0c0c0;
        }

        tr.trsty1 {
            text-align: left;
        }

        td.tdsty {
            text-align: left;
            font-weight: normal;
            border: 1px solid black;
            padding: 2px;
        }

        p.psty1 {
            font-family: Verdana,sans-serif;
            font-size: 9pt;
            font-weight: bold;
        }

        p.psty2 {
            font-family: Verdana,sans-serif;
            font-size: 9pt;
        }

        li.listy {
            font-family: Verdana,sans-serif;
            font-size: 9pt;
        }
    </style>
 </head>
 <body>
  <table class="tblsty">
   <tr align="left"><th colspan="3" class="thsty1">Table: <?php echo $sTableName; ?></th></tr>
   <tr><th class="thsty2">COLUMN NAME</th><th class="thsty2">DATABASE DATA TYPE</th><th class="thsty2">NULLABILITY</th></tr>

<?php

 #*------------------------------------------------------------*
 #* Pull the column names, data types and nullability.         *
 #*------------------------------------------------------------*
 $sQueryTABLEDEFN = "SELECT DB_ID,TABLE_ID,COLUMN_ID,COLUMN_NAME,DATA_TYPE,NULLABILITY FROM DATADICT_COLUMN_DEFN WHERE DB_ID=" . $DBID . " AND TABLE_ID=" . $TABLEID . " ORDER BY 3";

 #*------------------------------------------------------------*
 #* Query the dictionary to get the columns.                   *
 #*------------------------------------------------------------*
 $oResult = $oConn->query($sQueryTABLEDEFN);

 #*------------------------------------------------------------*
 #* Display all of the available tables as links.              *
 #*------------------------------------------------------------*
 while ($oRow = $oResult->fetch_assoc()) {
  printf("<tr><td class=\"tdsty\">%s</td><td class=\"tdsty\">%s</td><td class=\"tdsty\">%s</td></tr>",$oRow["COLUMN_NAME"],$oRow["DATA_TYPE"],$oRow["NULLABILITY"]);
 }

?>
  </table>

<?php
 #*------------------------------------------------------------*
 #* Pull the table description.                                *
 #*------------------------------------------------------------*
 $sQueryTABLEDESC = "SELECT TABLE_DESC FROM DATADICT_TABLE_DESC WHERE DB_ID=" . $DBID . " AND TABLE_ID=" . $TABLEID;

 #*------------------------------------------------------------*
 #* Query the dictionary to get the table description.         *
 #*------------------------------------------------------------*
 $oResult = $oConn->query($sQueryTABLEDESC);
 $oRow = $oResult->fetch_assoc();
 $sTableDesc = $oRow['TABLE_DESC'];
?>

  <p class="psty1">Table Description</p>
  <p class="psty2">&nbsp;<?php echo $sTableDesc; ?></p>

  <p class="psty1">Column Description</p>
  <ul>
<?php
 #*------------------------------------------------------------*
 #* Pull the column descriptions.                              *
 #*------------------------------------------------------------*
 $sQueryCOLUMNDESC = "SELECT COLUMN_NAME,COLUMN_DESC FROM DATADICT_COLUMN_DESC WHERE DB_ID=" . $DBID . " AND TABLE_ID=" . $TABLEID . " ORDER BY COLUMN_NAME";

 #*------------------------------------------------------------*
 #* Query the dictionary to get the column descriptions.       *
 #*------------------------------------------------------------*
 $oResult = $oConn->query($sQueryCOLUMNDESC);

 #*------------------------------------------------------------*
 #* Display all of the columns as list elements.               *
 #*------------------------------------------------------------*
 while ($oRow = $oResult->fetch_assoc()) {
  printf("<li class=\"listy\">%s: %s</li>",$oRow["COLUMN_NAME"],$oRow["COLUMN_DESC"]);
 }

?>
  </ul>

  <p class="psty1">Caveats</p>
  <ul>
<?php
 #*------------------------------------------------------------*
 #* Pull the caveats.                                          *
 #*------------------------------------------------------------*
 $sQueryCAVEATDESC = "SELECT CAVEAT_ID,CAVEAT_DESC FROM DATADICT_CAVEAT_DESC WHERE DB_ID=" . $DBID . " AND TABLE_ID=" . $TABLEID . " ORDER BY CAVEAT_ID";

 #*------------------------------------------------------------*
 #* Query the dictionary to get the caveat descriptions.       *
 #*------------------------------------------------------------*
 $oResult = $oConn->query($sQueryCAVEATDESC);

 #*------------------------------------------------------------*
 #* Display all of the caveats as list elements.               *
 #*------------------------------------------------------------*
 while ($oRow = $oResult->fetch_assoc()) {
  printf("<li class=\"listy\">%s</li>",$oRow["CAVEAT_DESC"]);
 }

?>
  </ul>

<?php

 $oResult->free();
 $oConn->close();

?>
 </body>
</html>