<?php

 #*------------------------------------------------------------*
 #* Pull in the DBID GET Variable from the link.               *
 #*------------------------------------------------------------*
 $DBID = $_GET["DBID"];

 #*------------------------------------------------------------*
 #* Pull in the FUNCPROCID GET Variable from the link.         *
 #*------------------------------------------------------------*
 $FUNCPROCID = $_GET["FUNCPROCID"];

 #*------------------------------------------------------------*
 #* Connect to the TESTDB MySQL database on the localhost.     *
 #* You will have to change localhost to the location of your  *
 #* database.  Contact your web administrator for more info.   *
 #*------------------------------------------------------------*
 $oConn = new mysqli("localhost","scott","tiger","TESTDB");

 #*------------------------------------------------------------*
 #* Ensure that the connection was successful.                 *
 #*------------------------------------------------------------*
 if ($oConn->connect_errno) {
  printf("Connection failed: %s\n", $oConn->connect_error);
  exit();
 }

 #*------------------------------------------------------------*
 #* Pull the name of the function or procedure based on the    *
 #* FUNCPROCID.                                                *
 #*------------------------------------------------------------*
 $sQueryFUNCPROCNAME = "SELECT FUNCPROC_NAME FROM DATADICT_FUNCPROC_NAME WHERE DB_ID=" . $DBID . " AND FUNCPROC_ID=" . $FUNCPROCID;

 #*------------------------------------------------------------*
 #* Query the dictionary to get the func/proc name.            *
 #*------------------------------------------------------------*
 $oResult = $oConn->query($sQueryFUNCPROCNAME);
 $oRow = $oResult->fetch_assoc();
 $sFuncProcName = $oRow['FUNCPROC_NAME'];

?>

<html>
 <head>
  <title>Company Dictionary - Function/Procedure Description</title>
    <style type="text/css">
        table.tblsty {
            font-family: Verdana,sans-serif;
            font-size: 9pt;
            border: 1px solid black;
            border-collapse: collapse;
            border-spacing: 20px;
        }

        th.thsty1 {
            text-align: left;
            font-weight: bold;
            border: 1px solid black;
            background: #808080;
        }

        th.thsty2 {
            text-align: center;
            font-weight: bold;
            border: 1px solid black;
            background: #c0c0c0;
        }

        tr.trsty1 {
            text-align: left;
        }

        td.tdsty {
            text-align: left;
            font-weight: normal;
            border: 1px solid black;
            padding: 2px;
        }

        p.psty1 {
            font-family: Verdana,sans-serif;
            font-size: 9pt;
            font-weight: bold;
        }

        p.psty2 {
            font-family: Verdana,sans-serif;
            font-size: 9pt;
        }

        li.listy {
            font-family: Verdana,sans-serif;
            font-size: 9pt;
        }
    </style>
 </head>
 <body>
  <table class="tblsty">
   <tr align="left"><th colspan="3" class="thsty1">Function/Procedure: <?php echo $sFuncProcName; ?></th></tr>
   <tr><th class="thsty2">ARGUMENT NAME</th><th class="thsty2">DIRECTION</th><th class="thsty2">DATA TYPE</th></tr>

<?php

 #*------------------------------------------------------------*
 #* Pull the argument names, directions and data types.        *
 #*------------------------------------------------------------*
 $sQueryFUNCPROCDEFN = "SELECT DB_ID,FUNCPROC_ID,ARGUMENT_ID,ARGUMENT_NAME,DIRECTION,DATATYPE FROM DATADICT_ARGUMENT_DEFN WHERE DB_ID=" . $DBID . " AND FUNCPROC_ID=" . $FUNCPROCID . " ORDER BY 3";

 #*------------------------------------------------------------*
 #* Query the dictionary to get the arguments.                 *
 #*------------------------------------------------------------*
 $oResult = $oConn->query($sQueryFUNCPROCDEFN);

 #*------------------------------------------------------------*
 #* Display all of the available arguments as links.           *
 #*------------------------------------------------------------*
 while ($oRow = $oResult->fetch_assoc()) {
  printf("<tr><td class=\"tdsty\">%s</td><td class=\"tdsty\">%s</td><td class=\"tdsty\">%s</td></tr>",$oRow["ARGUMENT_NAME"],$oRow["DIRECTION"],$oRow["DATATYPE"]);
 }

?>
  </table>

<?php
 #*------------------------------------------------------------*
 #* Pull in the func/proc description.                         *
 #*------------------------------------------------------------*
 $sQueryFUNCPROCDESC = "SELECT FUNCPROC_DESC FROM DATADICT_FUNCPROC_DESC WHERE DB_ID=" . $DBID . " AND FUNCPROC_ID=" . $FUNCPROCID;

 #*------------------------------------------------------------*
 #* Query the dictionary to get the func/proc description.     *
 #*------------------------------------------------------------*
 $oResult = $oConn->query($sQueryFUNCPROCDESC);
 $oRow = $oResult->fetch_assoc();
 $sFuncProcDesc = $oRow['FUNCPROC_DESC'];
?>

  <p class="psty1">Function/Procedure Description</p>
  <p class="psty2">&nbsp;<?php echo $sFuncProcDesc; ?></p>

  <p class="psty1">Argument Description</p>
  <ul>
<?php
 #*------------------------------------------------------------*
 #* Pull the argument descriptions.                            *
 #*------------------------------------------------------------*
 $sQueryARGUMENTDESC = "SELECT ARGUMENT_NAME,ARGUMENT_DESC FROM DATADICT_ARGUMENT_DESC WHERE DB_ID=" . $DBID . " AND FUNCPROC_ID=" . $FUNCPROCID . " ORDER BY ARGUMENT_NAME";

 #*------------------------------------------------------------*
 #* Query the dictionary to get the argument descriptions.     *
 #*------------------------------------------------------------*
 $oResult = $oConn->query($sQueryARGUMENTDESC);

 #*------------------------------------------------------------*
 #* Display all of the columns as list elements.               *
 #*------------------------------------------------------------*
 while ($oRow = $oResult->fetch_assoc()) {
  printf("<li class=\"listy\">%s: %s</li>",$oRow["ARGUMENT_NAME"],$oRow["ARGUMENT_DESC"]);
 }

?>
  </ul>

  <p class="psty1">Caveats</p>
  <ul>
<?php
 #*------------------------------------------------------------*
 #* Pull the caveats.                                          *
 #*------------------------------------------------------------*
 $sQueryCAVEATDESC = "SELECT CAVEAT_ID,CAVEAT_DESC FROM DATADICT_FUNCPROCCAVEAT_DESC WHERE DB_ID=" . $DBID . " AND FUNCPROC_ID=" . $FUNCPROCID . " ORDER BY CAVEAT_ID";

 #*------------------------------------------------------------*
 #* Query the dictionary to get the caveat descriptions.       *
 #*------------------------------------------------------------*
 $oResult = $oConn->query($sQueryCAVEATDESC);

 #*------------------------------------------------------------*
 #* Display all of the caveats as list elements.               *
 #*------------------------------------------------------------*
 while ($oRow = $oResult->fetch_assoc()) {
  printf("<li class=\"listy\">%s</li>",$oRow["CAVEAT_DESC"]);
 }

?>
  </ul>

<?php

 $oResult->free();
 $oConn->close();

?>
 </body>
</html>